"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Analytics = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

var Analytics = function Analytics() {
  var _this = this;

  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      segment = _ref.segment,
      writeKey = _ref.writeKey;

  (0, _classCallCheck2["default"])(this, Analytics);
  (0, _defineProperty2["default"])(this, "identify", function (userId) {
    var traits = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!userId) throw new Error('User id is required for analytics identify');
    if (!_lodash["default"].isEmpty(traits)) _this.segment.identifyWithTraits(userId, traits);else _this.segment.identify(userId);
  });
  (0, _defineProperty2["default"])(this, "track", function (event) {
    var properties = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!event) throw new Error('Event is required for analytics track');
    if (!_lodash["default"].isEmpty(properties)) _this.segment.trackWithProperties(event, properties);else _this.segment.track(event);
  });
  (0, _defineProperty2["default"])(this, "screen", function (screenName) {
    var properties = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!screenName) throw new Error('Screen name is required for analytics screen');
    if (!_lodash["default"].isEmpty(properties)) _this.segment.screenWithProperties(screenName, properties);else _this.segment.screen(screenName);
  });
  if (!segment) throw new Error('Segment.io is required');
  if (!writeKey) throw new Error('Segment writeKey is required');
  this.segment = segment;
  this.segment.initialize({
    androidWriteKey: writeKey,
    iosWriteKey: writeKey
  });
};

exports.Analytics = Analytics;
//# sourceMappingURL=Analytics.js.map