"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueueMutationLink = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _client = require("@apollo/client");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var QueueMutationLink = /*#__PURE__*/function (_ApolloLink) {
  (0, _inherits2["default"])(QueueMutationLink, _ApolloLink);

  var _super = _createSuper(QueueMutationLink);

  function QueueMutationLink() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        storage = _ref.storage,
        _ref$enableQueueStora = _ref.enableQueueStorage,
        enableQueueStorage = _ref$enableQueueStora === void 0 ? false : _ref$enableQueueStora;

    (0, _classCallCheck2["default"])(this, QueueMutationLink);
    _this = _super.call(this);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "open", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _ref3,
          apolloClient,
          resync,
          _args = arguments;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _ref3 = _args.length > 0 && _args[0] !== undefined ? _args[0] : {}, apolloClient = _ref3.apolloClient, resync = _ref3.resync;

              if (apolloClient) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return");

            case 3:
              _this.isOpen = true; //call the resync operation if necessary

              _context.t0 = resync;

              if (!_context.t0) {
                _context.next = 8;
                break;
              }

              _context.next = 8;
              return resync({
                apolloClient: apolloClient
              });

            case 8:
              _this.clearQueue();

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "close", function () {
      _this.isOpen = false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "request", function (operation, forward) {
      if (_this.isOpen) {
        return forward(operation);
      } else {
        //if it is close enqueue first before forwarding
        _this.enqueue({
          operation: operation
        });

        return new _client.Observable(function () {
          return function () {
            return {
              isOffline: true
            };
          };
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "enqueue", function (entry) {
      //if queue storage is disable then skip this
      if (!_this.enableQueueStorage) return;

      var item = _objectSpread({}, entry);

      var operation = item.operation;

      var _ref4 = operation || {},
          query = _ref4.query,
          variables = _ref4.variables;

      var definitions = [];
      if (query && query.definitions) definitions = query.definitions.filter(function (e) {
        return e.operation === 'mutation';
      }); //store only if there are values for query.definitions

      if (definitions.length > 0) {
        query.definitions = definitions;

        _this.queue.push({
          mutation: query,
          variables: variables
        }); //update the value of local storage


        _this.storage.setItem(_this.storeKey, JSON.stringify(_this.queue));
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearQueue", function () {
      //just exit if e
      if (!_this.enableQueueStorage) return;
      _this.queue = [];
    });
    if (!storage) throw new Error('Storage can be window.localStorage or AsyncStorage but was not set');
    _this.storage = storage;
    _this.storeKey = '@offlineQueueKey';
    _this.queue = [];
    _this.isOpen = true;
    _this.enableQueueStorage = enableQueueStorage;
    return _this;
  }

  return QueueMutationLink;
}(_client.ApolloLink);

exports.QueueMutationLink = QueueMutationLink;
//# sourceMappingURL=QueueMutationLink.js.map