"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SyncOfflineMutation = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var SyncOfflineMutation = function SyncOfflineMutation() {
  var _this = this;

  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      apolloClient = _ref.apolloClient,
      storage = _ref.storage,
      _ref$storeKey = _ref.storeKey,
      storeKey = _ref$storeKey === void 0 ? '@offlineQueueKey' : _ref$storeKey;

  (0, _classCallCheck2["default"])(this, SyncOfflineMutation);
  (0, _defineProperty2["default"])(this, "getOfflineData", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", _this.storage.getItem(_this.storeKey));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  (0, _defineProperty2["default"])(this, "hasOfflineData", function () {
    return !!(_this.offlineData && _this.offlineData.length > 0);
  });
  (0, _defineProperty2["default"])(this, "addOfflineData", function () {
    var queue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    //add only if there is a value
    if (queue && queue.length > 0) _this.storage.setItem(_this.storeKey, JSON.stringify(queue));
  });
  (0, _defineProperty2["default"])(this, "clearOfflineData", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _this.offlineData = [];
            return _context2.abrupt("return", _this.storage.removeItem(_this.storeKey));

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  (0, _defineProperty2["default"])(this, "init", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    var stored;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _this.getOfflineData();

          case 2:
            stored = _context3.sent;
            _this.offlineData = JSON.parse(stored) || [];

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  (0, _defineProperty2["default"])(this, "sync", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
    var uncommittedOfflineMutation;
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (_this.hasOfflineData()) {
              _context5.next = 2;
              break;
            }

            return _context5.abrupt("return");

          case 2:
            //return as promise, but in the end clear the storage
            uncommittedOfflineMutation = [];
            _context5.next = 5;
            return Promise.all(_this.offlineData.map( /*#__PURE__*/function () {
              var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(item) {
                return _regenerator["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.prev = 0;
                        _context4.next = 3;
                        return _this.apolloClient.mutate(item);

                      case 3:
                        _context4.next = 8;
                        break;

                      case 5:
                        _context4.prev = 5;
                        _context4.t0 = _context4["catch"](0);
                        //set the errored mutation to the stash
                        uncommittedOfflineMutation.push(item);

                      case 8:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4, null, [[0, 5]]);
              }));

              return function (_x) {
                return _ref6.apply(this, arguments);
              };
            }()));

          case 5:
            _context5.next = 7;
            return _this.clearOfflineData();

          case 7:
            //then add again the uncommited storage
            _this.addOfflineData(uncommittedOfflineMutation);

          case 8:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  })));
  if (!apolloClient) throw new Error('Apollo Client instance is required when syncing data, please assign value to it');
  if (!storage) throw new Error('Storage can be window.localStorage or AsyncStorage but was not set');
  this.apolloClient = apolloClient;
  this.storage = storage;
  this.storeKey = storeKey;
  this.offlineData = [];
};

exports.SyncOfflineMutation = SyncOfflineMutation;
//# sourceMappingURL=SyncOfflineMutation.js.map