"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildFetchMoreQuery = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

var buildFetchMoreQuery = function buildFetchMoreQuery(modelName, fetchMore, skip, searchString, sortObject) {
  var variables = (0, _pcmliUmbrella.buildQueryVariables)(skip, searchString, sortObject);

  var updateQuery = function updateQuery(previousResult, _ref) {
    var fetchMoreResult = _ref.fetchMoreResult;

    if (!fetchMoreResult) {
      return previousResult;
    }

    return Object.assign({}, previousResult, (0, _defineProperty2["default"])({}, modelName, [].concat((0, _toConsumableArray2["default"])(previousResult[modelName]), (0, _toConsumableArray2["default"])(fetchMoreResult[modelName]))));
  };

  return fetchMore({
    variables: variables,
    updateQuery: updateQuery
  });
};

exports.buildFetchMoreQuery = buildFetchMoreQuery;
//# sourceMappingURL=buildFetchMoreQuery.js.map