"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withDocument = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _hoc = require("@apollo/client/react/hoc");

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

var _lodash = _interopRequireDefault(require("lodash"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var withDocument = function withDocument(_ref) {
  var query = _ref.query,
      entity = _ref.entity,
      extraOptions = _ref.extraOptions,
      extraProps = _ref.extraProps,
      _ref$extraConfig = _ref.extraConfig,
      extraConfig = _ref$extraConfig === void 0 ? {} : _ref$extraConfig,
      paramsToFilter = _ref.paramsToFilter,
      namespace = _ref.namespace;

  var config = _objectSpread({
    options: function options(ownProps) {
      var searchString = {
        _id: null
      };

      if (paramsToFilter) {
        searchString = paramsToFilter({
          ownProps: ownProps
        });
      } else {
        var _id = _lodash["default"].get(ownProps, 'params.id') || ownProps.id || ownProps._id; //but if there is no value for _id then submit it with null values


        searchString = {
          _id: !_id ? null : _id
        };
      }

      searchString = JSON.stringify(searchString);
      var result = {
        variables: _objectSpread({}, (0, _pcmliUmbrella.buildQueryVariables)(0, searchString, null, 1))
      };
      var xOption = _lodash["default"].isFunction(extraOptions) ? extraOptions({
        ownProps: ownProps
      }) : extraOptions;
      result = _lodash["default"].merge(result, xOption);
      return result;
    },
    props: function props(args) {
      var data = args.data;

      var _ref2 = data || {},
          loading = _ref2.loading,
          fetchMore = _ref2.fetchMore,
          error = _ref2.error,
          variables = _ref2.variables,
          refetch = _ref2.refetch;

      var item = data && data[entity] && data[entity].length > 0 && data[entity][0];
      var result = {
        loading: loading,
        fetchMore: fetchMore,
        error: error,
        variables: variables,
        refetch: refetch,
        item: item,
        document: item,
        onRefresh: refetch
      }; //merge the extra configuration

      result = (0, _pcmliUmbrella.mergeExtraConfig)(result, extraProps, args); //if there is namespace specified, return all props on that name to fix the issue
      //of multiple name on single HOC

      if (namespace) {
        result = (0, _defineProperty2["default"])({}, namespace, _objectSpread({}, result));
      }

      return result;
    }
  }, extraConfig);

  return (0, _hoc.graphql)(query, config);
};

exports.withDocument = withDocument;
//# sourceMappingURL=withDocument.js.map