"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withForm = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reduxForm = require("redux-form");

var _wrapDisplayName = _interopRequireDefault(require("recompose/wrapDisplayName"));

var _recompose = require("recompose");

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

var _lodash = _interopRequireDefault(require("lodash"));

var _NetworkError = require("../common/NetworkError");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var withForm = function withForm() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  //setup the redux-form configuration
  var defaultValue = {
    //form: 'AppCommonReduxForm',
    enableReinitialize: true,
    touchOnBlur: false,
    touchOnChange: true
  };
  config = Object.assign({}, defaultValue, config); //generate a random name if it is not specified

  if (!config.form) config.form = "form_".concat(_pcmliUmbrella.Utils.generateId(5));
  var _config = config,
      getInitialValues = _config.getInitialValues;
  return function (WrappedComponent) {
    var With = /*#__PURE__*/function (_React$Component) {
      (0, _inherits2["default"])(With, _React$Component);

      var _super = _createSuper(With);

      function With(props) {
        var _this;

        (0, _classCallCheck2["default"])(this, With);
        _this = _super.call(this, props);
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
          initialValues: {}
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "saveText", 'Save');
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "showDelete", false);
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleError", function (errors, _ref) {
          var doc = _ref.doc,
              type = _ref.type;

          var throwError = function throwError(message) {
            var networkError = _lodash["default"].includes(message, 'Network error');

            if (networkError) throw new _NetworkError.NetworkError('NO_NETWORK', {
              message: message
            });else {
              var _onError = _this.props.onError;
              _onError && _onError("".concat(message, " "));
              throw new Error(message);
            }
          };

          var _this$props = _this.props,
              errored = _this$props.errored,
              onError = _this$props.onError;
          var _errors = errors,
              graphQLErrors = _errors.graphQLErrors; //execute the function if it's available

          errored && errored(errors, doc); //check the type to determine which error to throw

          var typeName = "on".concat(_pcmliUmbrella.Utils.humanize(type), "Error"); //e.g.onCreateError, onDeleteError, onUpdateError

          var typedError = _this.props[typeName];
          typedError && typedError({
            errors: errors,
            doc: doc
          });

          if (graphQLErrors && graphQLErrors.length > 0) {
            var errorMessageString = graphQLErrors[0].message;

            var parseError = _pcmliUmbrella.Utils.jsonTryParse(errorMessageString);

            if (parseError !== false) {
              errors = parseError;
              var validationError = errors[0].validationError;

              if (validationError) {
                onError && onError('Validation errors. Please update the fields highlighted as red');
                throw new _reduxForm.SubmissionError(validationError);
              } else {
                var message = errors[0].message;
                if (!message) message = errors[0];
                throwError(message);
              }
            } else {
              errors = graphQLErrors;
              var _message = errors[0].message;
              if (!_message) _message = errors[0];
              throwError(_message);
            }
          } else {
            //default error message when it got errors
            throwError(errors.message);
          }
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFormSubmit", function (_ref2) {
          var doc = _ref2.doc,
              action = _ref2.action,
              afterAction = _ref2.afterAction,
              beforeAction = _ref2.beforeAction,
              type = _ref2.type;

          var formAction = function formAction() {
            var onlineOp = function onlineOp() {
              return action(doc).then(function (response) {
                var reset = _this.props.reset; //call the form submission reset

                reset && reset(); //execute the after the operation

                afterAction && afterAction({
                  response: response,
                  doc: doc,
                  ownProps: _this.props
                }); //return also the result here

                return response;
              })["catch"](function (errors) {
                _this.handleError(errors, {
                  doc: doc,
                  type: type
                });
              });
            };

            return onlineOp();
          };

          if (beforeAction) {
            return beforeAction({
              doc: doc,
              action: formAction,
              ownProps: _this.props
            });
          } else {
            return formAction();
          }
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onUpdateAction", function (doc) {
          var _this$props2 = _this.props,
              onUpdate = _this$props2.onUpdate,
              beforeUpdate = _this$props2.beforeUpdate,
              afterUpdate = _this$props2.afterUpdate;
          beforeUpdate = config.beforeUpdate || beforeUpdate;
          afterUpdate = config.afterUpdate || afterUpdate;
          return _this.onFormSubmit({
            doc: doc,
            action: onUpdate,
            afterAction: afterUpdate,
            beforeAction: beforeUpdate,
            type: 'update'
          });
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDeleteAction", function (doc) {
          var _this$props3 = _this.props,
              onDelete = _this$props3.onDelete,
              beforeDelete = _this$props3.beforeDelete,
              afterDelete = _this$props3.afterDelete;
          beforeDelete = config.beforeDelete || beforeDelete;
          afterDelete = config.afterDelete || afterDelete;
          return _this.onFormSubmit({
            doc: doc,
            action: onDelete,
            afterAction: afterDelete,
            beforeAction: beforeDelete,
            type: 'delete'
          });
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCreateAction", function (doc) {
          var _this$props4 = _this.props,
              onCreate = _this$props4.onCreate,
              beforeCreate = _this$props4.beforeCreate,
              afterCreate = _this$props4.afterCreate;
          beforeCreate = config.beforeCreate || beforeCreate;
          afterCreate = config.afterCreate || afterCreate;
          return _this.onFormSubmit({
            doc: doc,
            action: onCreate,
            afterAction: afterCreate,
            beforeAction: beforeCreate,
            type: 'create'
          });
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCancelAction", function () {
          var _this$props5 = _this.props,
              onCancel = _this$props5.onCancel,
              reset = _this$props5.reset; //call the form submission reset

          reset && reset();
          onCancel && onCancel();
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSubmit", function (doc) {
          var onCreate = _this.props.onCreate;
          var saveAction = _this.onUpdateAction;
          if (onCreate) saveAction = _this.onCreateAction;
          return saveAction(doc);
        });
        var _this$props6 = _this.props,
            _onCreate = _this$props6.onCreate,
            _onDelete = _this$props6.onDelete;

        if (_onCreate) {
          _this.saveText = 'Add';
        }

        if (_onDelete) {
          _this.showDelete = true;
        }

        return _this;
      }

      (0, _createClass2["default"])(With, [{
        key: "componentWillMount",
        value: function componentWillMount() {
          if (getInitialValues) {
            var that = this;
            getInitialValues(this.props).then(function (initialValues) {
              that.setState({
                initialValues: initialValues
              });
            });
          }
        }
      }, {
        key: "render",
        value: function render() {
          var initialValues = this.state.initialValues;
          var formProps = {
            onDelete: this.onDeleteAction,
            onCreate: this.onCreateAction,
            onUpdate: this.onUpdateAction,
            onCancel: this.onCancelAction,
            onSubmit: this.onSubmit,
            showDelete: this.showDelete,
            saveText: this.saveText,
            handleError: this.handleError
          };
          return /*#__PURE__*/_react["default"].createElement(WrappedComponent, (0, _extends2["default"])({
            formProps: formProps,
            initialValues: initialValues
          }, this.props));
        }
      }]);
      return With;
    }(_react["default"].Component);

    With.displayName = (0, _wrapDisplayName["default"])(WrappedComponent, 'withForm');
    With = (0, _recompose.compose)((0, _reduxForm.reduxForm)(config))(With);
    return With;
  };
};

exports.withForm = withForm;
//# sourceMappingURL=withForm.js.map