"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withList = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _hoc = require("@apollo/client/react/hoc");

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

var _lodash = _interopRequireDefault(require("lodash"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var buildFetchMoreQuery = function buildFetchMoreQuery(modelName, fetchMore, skip, searchString, sortObject) {
  var variables = (0, _pcmliUmbrella.buildQueryVariables)(skip, searchString, sortObject);

  var updateQuery = function updateQuery(previousResult, _ref) {
    var fetchMoreResult = _ref.fetchMoreResult;

    if (!fetchMoreResult) {
      return previousResult;
    }

    return Object.assign({}, previousResult, (0, _defineProperty2["default"])({}, modelName, [].concat((0, _toConsumableArray2["default"])(previousResult[modelName]), (0, _toConsumableArray2["default"])(fetchMoreResult[modelName]))));
  };

  return fetchMore({
    variables: variables,
    updateQuery: updateQuery
  });
};

var withList = function withList(_ref2) {
  var query = _ref2.query,
      entity = _ref2.entity,
      extraOptions = _ref2.extraOptions,
      extraProps = _ref2.extraProps,
      _ref2$extraConfig = _ref2.extraConfig,
      extraConfig = _ref2$extraConfig === void 0 ? {} : _ref2$extraConfig,
      paramsToFilter = _ref2.paramsToFilter,
      namespace = _ref2.namespace;

  var config = _objectSpread({
    options: function options(ownProps) {
      var sortObject = ownProps.sortObject,
          limit = ownProps.limit;
      var searchString = ownProps.searchString;

      if (paramsToFilter) {
        searchString = JSON.stringify(paramsToFilter({
          ownProps: ownProps
        }));
      }

      var result = {
        variables: (0, _pcmliUmbrella.buildQueryVariables)(0, searchString, sortObject, limit),
        notifyOnNetworkStatusChange: true
      };
      var xOption = _lodash["default"].isFunction(extraOptions) ? extraOptions({
        ownProps: ownProps
      }) : extraOptions;
      result = _lodash["default"].merge(result, xOption);
      return result;
    },
    props: function props(args) {
      var data = args.data;

      var _ref3 = data || {},
          loading = _ref3.loading,
          fetchMore = _ref3.fetchMore,
          error = _ref3.error,
          variables = _ref3.variables,
          refetch = _ref3.refetch,
          pageInfo = _ref3.pageInfo;

      var items = data && data[entity]; //get the pageInfo from server for backward compatibility, and if it's not available then use the new way

      pageInfo = pageInfo || data && data["".concat(entity, "Meta")];
      var result = {
        loading: loading,
        error: error,
        variables: variables,
        refetch: refetch,
        items: items,
        list: items,
        pageInfo: pageInfo,
        loadMoreEntries: function loadMoreEntries(skip, searchString, sortObject) {
          return buildFetchMoreQuery(entity, fetchMore, skip, searchString, sortObject);
        }
      };
      result = (0, _pcmliUmbrella.mergeExtraConfig)(result, extraProps, args); //if there is namespace specified, return all props on that name to fix the issue
      //of multiple name on single HOC

      if (namespace) {
        result = (0, _defineProperty2["default"])({}, namespace, _objectSpread({}, result));
      }

      return result;
    }
  }, extraConfig);

  return (0, _hoc.graphql)(query, config);
};

exports.withList = withList;
//# sourceMappingURL=withList.js.map