"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withMongoSearch = exports.handleSearchFn = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _wrapDisplayName = _interopRequireDefault(require("recompose/wrapDisplayName"));

var _lodash = _interopRequireDefault(require("lodash"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var handleSearchFn = function handleSearchFn(_ref) {
  var searchValue = _ref.searchValue,
      fields = _ref.fields;
  var filterObject = {}; //if searchValue  is NOT empty, then build a searchString

  if (searchValue !== '') {
    filterObject = {
      $or: []
    }; //iterate thru all fields if there is something to seach

    fields && fields.forEach(function (m) {
      var obj = {};

      if (m.type && m.type.toLowerCase() === 'array') {
        obj[m.name] = {
          $elemMatch: {
            $regex: searchValue,
            $options: 'i'
          }
        };
      } else if (m.type && m.type.toLowerCase() === 'number') {
        var value = _lodash["default"].toNumber(searchValue);

        if (!isNaN(value)) obj[m.name] = value;
      } else if (m.type && m.type.toLowerCase() === 'objectarray') {
        // the name should followed by the following format
        //contacts.$.address1.gps.lat, take note about the dollar sign to indicate about the array
        //split the m.name by "."
        var objectArrayName = m.name.split('.', 3); //the first item is the name

        obj[objectArrayName[0]] = {
          $elemMatch: (0, _defineProperty2["default"])({}, objectArrayName[2], {
            $regex: searchValue,
            $options: 'i'
          })
        };
      } else {
        obj[m.name] = {
          $regex: searchValue,
          $options: 'i'
        };
      }

      filterObject['$or'].push(obj);
    });
  }

  var searchString = JSON.stringify(filterObject);
  return {
    searchString: searchString,
    searchObject: filterObject,
    searchFields: fields
  };
};

exports.handleSearchFn = handleSearchFn;

var withMongoSearch = function withMongoSearch() {
  return function (WrappedComponent) {
    var With = /*#__PURE__*/function (_React$Component) {
      (0, _inherits2["default"])(With, _React$Component);

      var _super = _createSuper(With);

      function With() {
        var _this;

        (0, _classCallCheck2["default"])(this, With);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _super.call.apply(_super, [this].concat(args));
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSearch", /*#__PURE__*/function () {
          var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(searchValue) {
            var _this$props, onSearch, fields, _handleSearchFn, searchString, searchObject, searchFields;

            return _regenerator["default"].wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _this$props = _this.props, onSearch = _this$props.onSearch, fields = _this$props.fields;
                    _handleSearchFn = handleSearchFn({
                      searchValue: searchValue,
                      onSearch: onSearch,
                      fields: fields
                    }), searchString = _handleSearchFn.searchString, searchObject = _handleSearchFn.searchObject, searchFields = _handleSearchFn.searchFields;
                    onSearch({
                      searchString: searchString,
                      searchValue: searchValue,
                      searchObject: searchObject,
                      searchFields: searchFields
                    });

                  case 3:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          return function (_x) {
            return _ref2.apply(this, arguments);
          };
        }());
        return _this;
      }

      (0, _createClass2["default"])(With, [{
        key: "render",
        value: function render() {
          var mongoSearch = {
            handleSearch: this.handleSearch
          };
          return /*#__PURE__*/_react["default"].createElement(WrappedComponent, (0, _extends2["default"])({}, mongoSearch, this.props));
        }
      }]);
      return With;
    }(_react["default"].Component);

    With.displayName = (0, _wrapDisplayName["default"])(WrappedComponent, 'withMongoSearch');
    return With;
  };
};

exports.withMongoSearch = withMongoSearch;
//# sourceMappingURL=index.js.map