"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withRole = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _hoc = require("@apollo/client/react/hoc");

var _client = require("@apollo/client");

var _recompose = require("recompose");

var _lodash = _interopRequireDefault(require("lodash"));

var _templateObject;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var getRoleName = function getRoleName(_ref) {
  var ownProps = _ref.ownProps,
      roleName = _ref.roleName;
  return _lodash["default"].get(ownProps, 'roleName.value') || _lodash["default"].get(ownProps, 'roleName') || _lodash["default"].get(roleName, 'value') || roleName;
};

var withRole = function withRole() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      roleName = _ref2.roleName;

  var withRoleQuery = (0, _client.gql)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2["default"])(["\n    query hasRole($name: String!) {\n      hasRole(name: $name)\n    }\n  "])));
  var withRoleConfig = {
    options: function options(ownProps) {
      //for backward and future compatibility, check from value and roleName itself
      var name = getRoleName({
        ownProps: ownProps,
        roleName: roleName
      }); //include the fetch policy it can re-use the cache

      return {
        skip: !name,
        variables: {
          name: name
        },
        fetchPolicy: 'cache-first',
        name: 'hasRole'
      };
    },
    props: function props(_ref3) {
      var data = _ref3.data;
      var _data$hasRole = data.hasRole,
          hasRole = _data$hasRole === void 0 ? false : _data$hasRole;
      return {
        hasRole: hasRole
      };
    },
    //when there is no roleName do not execute this operation
    skip: function skip(ownProps) {
      return !getRoleName({
        ownProps: ownProps,
        roleName: roleName
      });
    }
  };
  return (0, _recompose.compose)((0, _hoc.graphql)(withRoleQuery, withRoleConfig), (0, _recompose.mapProps)(function (ownProps) {
    var roleNameProps = getRoleName({
      ownProps: ownProps,
      roleName: roleName
    }); //ownProps.roleName || roleName

    var role = _lodash["default"].pick(ownProps, ['hasRole']);

    role = _objectSpread(_objectSpread({}, role), {}, {
      roleName: roleNameProps
    });

    var result = _lodash["default"].omit(ownProps, ['hasRole']); //combined them as new props


    result = _objectSpread(_objectSpread({}, result), {}, {
      role: role
    });
    return result;
  }));
};

exports.withRole = withRole;
//# sourceMappingURL=index.js.map