"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withUser = exports.getUserStatus = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _client = require("@apollo/client");

var _react = _interopRequireDefault(require("react"));

var _recompose = require("recompose");

var _wrapDisplayName = _interopRequireDefault(require("recompose/wrapDisplayName"));

var _lodash = _interopRequireDefault(require("lodash"));

var _withDocument = require("../withDocument");

var _templateObject;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var getUserStatus = function getUserStatus(_ref) {
  var user = _ref.user;

  var _ref2 = user || {},
      tenantId = _ref2.tenantId,
      status = _ref2.status,
      _ref2$roles = _ref2.roles,
      roles = _ref2$roles === void 0 ? [] : _ref2$roles,
      _id = _ref2._id;

  var hasTenant = !!tenantId;
  var isPending = status === 'pending';
  var isActive = status === 'active';
  var isInActive = status === 'inactive';
  var loggedIn = !!_id;

  var isSuperAdmin = _lodash["default"].includes(roles, 'superAdmin');

  return {
    loggedIn: loggedIn,
    hasTenant: hasTenant,
    isPending: isPending,
    isActive: isActive,
    isInActive: isInActive,
    isSuperAdmin: isSuperAdmin
  };
};

exports.getUserStatus = getUserStatus;

var withUser = function withUser() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  console.warn('DEPRECATED: useUser as alternative');
  var query = config.query;
  query = query || (0, _client.gql)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2["default"])(["query allUser($filter: String, $options: String) {\n  allUser(filter: $filter, options: $options ) {\n    _id\n    status\n    tenantId\n    driverId\n    profile {\n      name\n      picture\n      email\n    }\n    roles\n  }\n}\n"])));
  return function (WrappedComponent) {
    var With = /*#__PURE__*/function (_React$Component) {
      (0, _inherits2["default"])(With, _React$Component);

      var _super = _createSuper(With);

      function With() {
        var _this;

        (0, _classCallCheck2["default"])(this, With);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _super.call.apply(_super, [this].concat(args));
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getStatus", function () {
          var document = _this.props.document;
          return getUserStatus({
            user: document
          });
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_logout", function () {
          var _this$props = _this.props,
              logout = _this$props.logout,
              history = _this$props.history;
          logout && logout({
            history: history
          });
        });
        (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "redirectAuthenticatedUser", function (_ref3) {
          var redirectPath = _ref3.redirectPath;
          var authRedirect = _this.props.authRedirect;
          return authRedirect.authenticatedUser({
            redirectPath: redirectPath,
            userStatus: _this.getStatus()
          });
        });
        return _this;
      }

      (0, _createClass2["default"])(With, [{
        key: "render",
        value: function render() {
          var _this$props2 = this.props,
              document = _this$props2.document,
              loading = _this$props2.loading,
              loggingIn = _this$props2.loggingIn;
          var status = this.getStatus();

          var user = _objectSpread(_objectSpread({}, status), {}, {
            loading: loading,
            loggingIn: loggingIn,
            logout: this._logout,
            redirectAuthenticatedUser: this.redirectAuthenticatedUser
          }, document);

          return /*#__PURE__*/_react["default"].createElement(WrappedComponent, (0, _extends2["default"])({
            user: user
          }, this.props));
        }
      }]);
      return With;
    }(_react["default"].Component);

    With.displayName = (0, _wrapDisplayName["default"])(WrappedComponent, 'withUser');
    With = (0, _recompose.compose)((0, _withDocument.withDocument)({
      query: query,
      entity: 'allUser'
    }))(With);
    return With;
  };
};

exports.withUser = withUser;
//# sourceMappingURL=index.js.map