"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withViewToggle = exports.withModeHandlers = exports.withModeState = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _recompose = require("recompose");

var modes = ['edit', 'view'];
var withModeState = (0, _recompose.withState)('mode', 'toggleView', 'view');
exports.withModeState = withModeState;
var withModeHandlers = (0, _recompose.withHandlers)({
  onToggle: function onToggle(_ref) {
    var toggleView = _ref.toggleView;
    return function (event) {
      toggleView(function (mode) {
        //if it cannot find any value then indexOf will return -1
        var index = _lodash["default"].indexOf(modes, mode); //if the value is already at the end get back on the first item


        if (index + 1 >= modes.length) index = -1; //always increment the value to get the next index

        index++; //this will be the new value for mode

        return modes[index];
      });
    };
  }
});
exports.withModeHandlers = withModeHandlers;
var withViewToggle = (0, _recompose.compose)(withModeState, withModeHandlers);
exports.withViewToggle = withViewToggle;
//# sourceMappingURL=withViewToggle.js.map