"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDocument = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

var _useList = require("../useList");

var _lodash = require("lodash");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useDocument = function useDocument() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      query = _ref.query,
      entity = _ref.entity,
      _id = _ref._id,
      projection = _ref.projection,
      sort = _ref.sort,
      filter = _ref.filter,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? {} : _ref$options,
      _ref$useListProxy = _ref.useListProxy,
      useListProxy = _ref$useListProxy === void 0 ? _useList.useList : _ref$useListProxy;

  _pcmliUmbrella.Utils.requiredCheck(query, 'useDocument.query');

  _pcmliUmbrella.Utils.requiredCheck(entity, 'useDocument.entity'); //if id is specified override the filter, and filter it by _id


  if (!(0, _lodash.isEmpty)(_id) || _id === null) {
    filter = {
      _id: _id
    };
  } //always the first item on the query will be the result


  var skip = 0;
  var limit = 1;
  var listResult = useListProxy({
    query: query,
    entity: entity,
    projection: projection,
    sort: sort,
    limit: limit,
    skip: skip,
    filter: filter,
    options: options
  });
  var document = (0, _lodash.get)(listResult, 'list', null);

  if ((0, _lodash.isArray)(document)) {
    document = (0, _lodash.get)(listResult, 'list[0]');
  }

  var result = (0, _lodash.omit)(listResult, ['list', 'pageInfo', 'loadMoreEntries']); //return the result, other apollo related result are included from useList

  return _objectSpread(_objectSpread({}, result), {}, {
    document: document
  });
};

exports.useDocument = useDocument;
//# sourceMappingURL=index.js.map