"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useListAction = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _lodash = require("lodash");

var _react = _interopRequireDefault(require("react"));

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

var _defaultSort = {
  _id: 1
};
/**
 * This is common action that the list have,
 * This is another variation for useStoredListAction
 * @returns {*}
 */

var useListAction = function useListAction() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$defaultSort = _ref.defaultSort,
      defaultSort = _ref$defaultSort === void 0 ? _defaultSort : _ref$defaultSort,
      defaultSearch = _ref.defaultSearch;

  var _React$useState = _react["default"].useState(defaultSort),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      sort = _React$useState2[0],
      setSort = _React$useState2[1];

  var _React$useState3 = _react["default"].useState(defaultSearch),
      _React$useState4 = (0, _slicedToArray2["default"])(_React$useState3, 2),
      filter = _React$useState4[0],
      setFilter = _React$useState4[1];

  var _React$useState5 = _react["default"].useState(null),
      _React$useState6 = (0, _slicedToArray2["default"])(_React$useState5, 2),
      searchValue = _React$useState6[0],
      setSearchValue = _React$useState6[1];

  var _React$useState7 = _react["default"].useState(null),
      _React$useState8 = (0, _slicedToArray2["default"])(_React$useState7, 2),
      filterTemplate = _React$useState8[0],
      setFilterTemplate = _React$useState8[1];

  var _React$useState9 = _react["default"].useState(null),
      _React$useState10 = (0, _slicedToArray2["default"])(_React$useState9, 2),
      searchObj = _React$useState10[0],
      setSearchObj = _React$useState10[1];

  var onSort = _react["default"].useCallback(function (_ref2) {
    var sortObject = _ref2.sortObject;
    setSort(sortObject === null || sortObject === void 0 ? void 0 : sortObject.sort);
  }, []);

  var onSearch = _react["default"].useCallback(function (_ref3) {
    var searchObject = _ref3.searchObject,
        searchValue = _ref3.searchValue;
    setSearchValue(searchValue); //include the default search on search object

    searchObject = (0, _lodash.merge)({}, defaultSearch, searchObject); //combine the value from the filter and the search object

    var finalSearch = searchObject;

    if (!(0, _lodash.isEmpty)(filterTemplate)) {
      finalSearch = {
        $and: [finalSearch, filterTemplate]
      };
    }

    console.log('the filter was set onSearch');
    setFilter(finalSearch);
    setSearchObj(searchObject);
  }, [filterTemplate]);

  var onFilter = _react["default"].useCallback(function (_ref4) {
    var template = _ref4.template;

    var searchPredicate = _pcmliUmbrella.Utils.filterToObject(template === null || template === void 0 ? void 0 : template.value); //include the default search on search object


    var newSearchObject = (0, _lodash.merge)({}, defaultSearch, searchObj); //combine the value from the filter and the search object

    var finalSearch = searchPredicate;

    if (!(0, _lodash.isEmpty)(newSearchObject)) {
      finalSearch = {
        $and: [finalSearch, newSearchObject]
      };
    }

    setFilter(finalSearch);
    setFilterTemplate(searchPredicate);
  }, [searchObj]);

  return {
    filter: filter,
    sort: sort,
    searchValue: searchValue,
    onSort: onSort,
    onSearch: onSearch,
    onFilter: onFilter
  };
};

exports.useListAction = useListAction;
//# sourceMappingURL=useListAction.js.map