"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useMutation = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _client = require("@apollo/client");

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

var _lodash = _interopRequireDefault(require("lodash"));

var useMutation = function useMutation() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      query = _ref.query,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? {} : _ref$options,
      _ref$useMutationProxy = _ref.useMutationProxy,
      useMutationProxy = _ref$useMutationProxy === void 0 ? _client.useMutation : _ref$useMutationProxy;

  _pcmliUmbrella.Utils.requiredCheck(query, 'useMutation.query'); //setup the variables


  var _options$mutationOpti = options.mutationOptions,
      mutationOptions = _options$mutationOpti === void 0 ? {} : _options$mutationOpti; //just return the result of this operation

  var _useMutationProxy = useMutationProxy(query, mutationOptions),
      _useMutationProxy2 = (0, _slicedToArray2["default"])(_useMutationProxy, 2),
      mutate = _useMutationProxy2[0],
      mutationResult = _useMutationProxy2[1];

  var executeIt = function executeIt(_ref2) {
    var _id = _ref2._id,
        filter = _ref2.filter,
        input = _ref2.input;

    //prepare for the variable filter
    //throw error both  filter and _id are undefined
    var inputId = _lodash["default"].get(input, '_id');

    if (_id === undefined && filter === undefined && inputId === undefined) {
      throw new Error('_id or filter  or input._id needs to be specified');
    } //if id is specified override the filter, and filter it by _id


    if (!_lodash["default"].isEmpty(_id) || _id === null) {
      filter = {
        _id: _id
      };
    } else if (!_lodash["default"].isEmpty(inputId) || inputId === null) {
      filter = {
        _id: inputId
      };
    } //prepare for the variable filter


    var filterString = filter ? JSON.stringify(filter) : ''; //prepare for the input variable

    var doc = _lodash["default"].omit(input, ['_id']);

    var inputString = JSON.stringify(doc); //extract the options that can passed to mutate

    var _ref3 = mutationOptions || {},
        optimisticResponse = _ref3.optimisticResponse,
        refetchQueries = _ref3.refetchQueries,
        update = _ref3.update; //return the mutate promise


    return mutate({
      optimisticResponse: optimisticResponse,
      refetchQueries: refetchQueries,
      update: update,
      variables: {
        filter: filterString,
        input: inputString
      }
    });
  };

  return [executeIt, mutate, mutationResult];
};

exports.useMutation = useMutation;
//# sourceMappingURL=index.js.map