"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useReportUrl = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _lodash = require("lodash");

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useReportUrl = function useReportUrl(_ref) {
  var url = _ref.url,
      query = _ref.query,
      fileName = _ref.fileName,
      accessToken = _ref.accessToken;

  var _React$useState = _react["default"].useState(null),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      reportUrl = _React$useState2[0],
      setReportUrl = _React$useState2[1];

  var buildUrl = _react["default"].useCallback(function (_ref2) {
    var url = _ref2.url,
        query = _ref2.query,
        fileName = _ref2.fileName,
        _ref2$timeStamp = _ref2.timeStamp,
        timeStamp = _ref2$timeStamp === void 0 ? undefined : _ref2$timeStamp;

    var btoa = _pcmliUmbrella.Base64.btoa(_objectSpread(_objectSpread({
      accessToken: accessToken
    }, query), {}, {
      timeStamp: timeStamp
    }));

    var _url = "".concat(url, "/").concat(btoa, "/").concat(fileName);

    setReportUrl(_url);
  }, [accessToken]);

  var refreshUrl = _react["default"].useCallback(function (options) {
    var timeStamp = new Date().getTime();
    var mergeArgs = (0, _lodash.merge)({
      url: url,
      query: query,
      fileName: fileName,
      timeStamp: timeStamp
    }, options);
    buildUrl(mergeArgs);
  }, [url, query, fileName, buildUrl]);

  _react["default"].useEffect(function () {
    buildUrl({
      url: url,
      query: query,
      fileName: fileName
    });
  }, [url, query, fileName]);

  return {
    refreshUrl: refreshUrl,
    reportUrl: reportUrl
  };
};

exports.useReportUrl = useReportUrl;
//# sourceMappingURL=index.js.map