"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRole = void 0;

var _client = require("@apollo/client");

var _graphql = require("./graphql");

var _lodash = require("lodash");

var useRole = function useRole() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      roleName = _ref.roleName,
      _ref$useQueryProxy = _ref.useQueryProxy,
      useQueryProxy = _ref$useQueryProxy === void 0 ? _client.useQuery : _ref$useQueryProxy;

  var options = {
    skip: !roleName,
    variables: {
      name: roleName
    },
    fetchPolicy: 'cache-first',
    name: 'hasRole',
    nextFetchPolicy: "cache-first"
  };
  var roleDocument = useQueryProxy(_graphql.query, options);
  var hasRole = (0, _lodash.get)(roleDocument, 'data.hasRole', false);
  return {
    hasRole: hasRole,
    roleName: roleName
  };
};

exports.useRole = useRole;
//# sourceMappingURL=index.js.map