"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useUser = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _client = require("@apollo/client");

var _useDocument = require("../useDocument");

var _graphql = require("./graphql");

var _lodash = require("lodash");

var _pcmliUmbrella = require("pcmli.umbrella.uni-core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var getUserStatus = function getUserStatus(_ref) {
  var user = _ref.user;

  var _ref2 = user || {},
      tenantId = _ref2.tenantId,
      status = _ref2.status,
      _ref2$roles = _ref2.roles,
      roles = _ref2$roles === void 0 ? [] : _ref2$roles,
      _id = _ref2._id;

  var hasTenant = !!tenantId;
  var isPending = status === 'pending';
  var isActive = status === 'active';
  var isInActive = status === 'inactive';
  var loggedIn = !!_id;
  var isSuperAdmin = (0, _lodash.includes)(roles, 'superAdmin');
  return {
    loggedIn: loggedIn,
    hasTenant: hasTenant,
    isPending: isPending,
    isActive: isActive,
    isInActive: isInActive,
    isSuperAdmin: isSuperAdmin
  };
};

var useUser = function useUser(_ref3) {
  var query = _ref3.query,
      _id = _ref3._id,
      filter = _ref3.filter,
      options = _ref3.options,
      projection = _ref3.projection,
      sort = _ref3.sort,
      _ref3$useDocumentProx = _ref3.useDocumentProxy,
      useDocumentProxy = _ref3$useDocumentProx === void 0 ? _useDocument.useDocument : _ref3$useDocumentProx,
      _ref3$useMutationProx = _ref3.useMutationProxy,
      useMutationProxy = _ref3$useMutationProx === void 0 ? _client.useMutation : _ref3$useMutationProx;
  query = query || _graphql.queries.singleConfig.query;
  options = (0, _lodash.merge)({
    queryOptions: {
      fetchPolicy: 'cache-first'
    }
  }, options);
  var userDocument = useDocumentProxy({
    query: query,
    entity: 'allUser',
    _id: _id,
    filter: filter,
    options: options,
    projection: projection,
    sort: sort
  }); //just remove the document field name and replace it as user

  userDocument.user = (0, _lodash.get)(userDocument, 'document');
  userDocument = (0, _lodash.omit)(userDocument, 'document');
  var status = getUserStatus({
    user: userDocument.user
  });

  var _useMutationProxy = useMutationProxy(_graphql.logoutQuery),
      _useMutationProxy2 = (0, _slicedToArray2["default"])(_useMutationProxy, 1),
      mutate = _useMutationProxy2[0];

  var logout = function logout() {
    var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        accessToken = _ref4.accessToken;

    _pcmliUmbrella.Utils.requiredCheck(accessToken, 'logout.accessToken');

    return mutate({
      variables: {
        accessToken: accessToken
      }
    });
  };

  return _objectSpread(_objectSpread(_objectSpread({}, userDocument), status), {}, {
    logout: logout,
    getUserStatus: getUserStatus
  });
};

exports.useUser = useUser;
//# sourceMappingURL=index.js.map