"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GenericAction = exports.ButtonOnPress = exports.RejectedPromise = exports.ResolvedPromise = void 0;

var _addonActions = require("@storybook/addon-actions");

var ResolvedPromise = function ResolvedPromise() {
  var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'What a success';
  return new Promise(function (resolve) {
    setTimeout(function () {
      (0, _addonActions.action)('Resolved Promise')(message);
      resolve();
    }, 3000);
  });
};

exports.ResolvedPromise = ResolvedPromise;

var RejectedPromise = function RejectedPromise() {
  var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Sucks, it fails';
  return new Promise(function (resolve, reject) {
    setTimeout(function () {
      (0, _addonActions.action)('Rejected Promise')(message);
      reject();
    }, 3000);
  });
};

exports.RejectedPromise = RejectedPromise;

var ButtonOnPress = function ButtonOnPress(message) {
  GenericAction({
    message: message,
    actionName: 'BUTTON_PRESS'
  });
};

exports.ButtonOnPress = ButtonOnPress;

var GenericAction = function GenericAction() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      message = _ref.message,
      actionName = _ref.actionName;

  message = message || 'The action was committed';
  actionName = actionName || 'Common action';
  (0, _addonActions.action)(actionName)(message);
};

exports.GenericAction = GenericAction;
//# sourceMappingURL=StorybookUtils.js.map